// ======================================================================
// cNNTPTst.cpp - test program for a simple NNTP client shell
//               usage: "./cNNTPTst <IP address>"
// 
// 042101: Benjamin Han <benhdj@cs.cmu.edu> Changed the license from GPL to
//         LGPL.
// 020201: Benjamin Han <benhdj@cs.cmu.edu> namespace Toolbox.
// 012901: Benjamin Han <benhdj@cs.cmu.edu> Created
// ======================================================================

//    Copyright (C) 2000-2004 Benjamin Han <benhdj@cs.cmu.edu>
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "cNNTP.hpp"

using namespace Toolbox;
using namespace std;

void printHelp () {
  cerr<<"* cNNTPTst: test program for a simple NNTP client shell by Benjamin Han"<<endl;
  cerr<<"* Usage: ./cNNTPTst <IP address>"<<endl;
}

int main (int argc, char *argv[]) {
  NNTPClient newsReader;
  NNTPResponse r;
  string cmd;

  if (argc!=2) {
    printHelp();
    return -1;
  }
  
  if (newsReader.connect(argv[1],r)!=-1) {
    cout<<"* Welcome msg: "<<r<<endl;
      
    do {
      r.clear();
      cout<<"* Command: ";
      getline(cin,cmd);
      cout<<"* exec() returns: "<<newsReader.exec(cmd,r)<<endl;
      cout<<"* Full response: "<<endl;
      cout<<r<<endl;
    } while (cmd!="quit");
  }
  else {
    cerr<<"* Cann't connect to the NNTP server."<<endl;
    return 1;
  }

  return 0;
}
