// ======================================================================
// misc.hpp - misc. useful functions.
// 
// 122502: Benjamin Han <benhdj@cs.cmu.edu> removed "using namespace std;" 
//         and inserted std:: prefix where needed.
// 063001: Benjamin Han <benhdj@cs.cmu.edu> Added
//         isInteger(const string&,int&).
// 042101: Benjamin Han <benhdj@cs.cmu.edu> Changed the license from GPL to
//         LGPL.
// 020201: Benjamin Han <benhdj@cs.cmu.edu> namespace Toolbox.
// 012901: Benjamin Han <benhdj@cs.cmu.edu> Added isInteger().
// 010201: Benjamin Han <benhdj@cs.cmu.edu> Added isBlankLine() and
//         replace*() functions.
// 010101: Benjamin Han <benhdj@cs.cmu.edu> Created.
// ======================================================================

//    Copyright (C) 2000-2004 Benjamin Han <benhdj@cs.cmu.edu>
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MISC_HPP
#define MISC_HPP

#include "tbconsts.hpp"

#include <string>

namespace Toolbox {

void intToString (int i, std::string &str);
bool isBlankLine (const std::string &str);        // return true iff 'str' is blank
bool isInteger (const std::string &str);          // return true iff 'str' is an integer
bool isInteger (const std::string &str, int &i);  // same with above but i is the integer

// replace*() replace pattern 'pat' with 'nStr' - they return true iff any
// replacement occurs
bool replaceOnce (std::string &str, const std::string &pat, const std::string &nStr, std::string::size_type idx);
bool replaceAll (std::string &str, const std::string &pat, const std::string &nStr, std::string::size_type idx);

};

#endif
