// ======================================================================
// tbconsts.hpp - various constant definitions for Toolbox.
// 
// 112002: Benjamin Han <benhdj@cs.cmu.edu> Added stuff so MS VC6 could
//         compile; make every component include this file.
// 042101: Benjamin Han <benhdj@cs.cmu.edu> Changed the license from GPL to
//         LGPL.
// 020201: Benjamin Han <benhdj@cs.cmu.edu> namespace Toolbox.
// 013001: Benjamin Han <benhdj@cs.cmu.edu> Added PUNC_STR.
// 010201: Benjamin Han <benhdj@cs.cmu.edu> Created.
// ======================================================================

//    Copyright (C) 2000-2004 Benjamin Han <benhdj@cs.cmu.edu>
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef TBCONSTS_HPP
#define TBCONSTS_HPP

namespace Toolbox {

#define WHITESPACE_STR " \t\f\r\n"
#define PUNC_STR       "~!@#$%^&*(){}[]<>,.?/:\";'_+|`-=\\"

#if _MSC_VER==1200

// for M$ VC6, disable the warnings about names too long for debugging info
#pragma warning(disable: 4786 4788)

// due to poor standard compliance of M$ VC6, everything is public to avoid
// template friend compilation problems
#define protected public
#define private public

#endif

};

#endif
