// ======================================================================
// trieTst.hpp - simple testing code for trie.hpp and labelTrie.hpp.
// 
// 111202: Benjamin Han <benhdj@cs.cmu.edu> Created by simplifying trie.hpp.
// ======================================================================

//    Copyright (C) 2000-2004 Benjamin Han <benhdj@cs.cmu.edu>
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <iostream>
#include <string>

#include "treeAlgorithm.hpp"
#include "trie.hpp"
#include "labelTrie.hpp"

using namespace std;
using namespace Toolbox;

// just so we can set a default value
struct Int {
  int i;
  Int ():i(0) {}
  Int (int i):i(i) {}
};

ostream &operator << (ostream &os, const Int &i) {  
  return os<<i.i;
}

int main () {
  Trie<string,Int> t1;
  LabelTrie<string> t2;

  // prefix type is the same in both Trie<> and LabelTrie<>
  Trie<string,Int>::Prefix p1;
  LabelTrie<string>::Prefix p2;

  Trie<string,Int>::Iterator i1;

  p1.push_back("apple");
  p1.push_back("banana");
  p1.push_back("orange");

  p2=p1;
  p2.erase(--p2.end());
  p2.push_back("peach");

  i1=t1.addPrefix(p1);
  i1.get().data=10;
  t1.addPrefix(p2,20);

  t2.addPrefix(p1);
  t2.addPrefix(p2);

  cout<<t1<<endl;
  cout<<t2<<endl;

  cout<<*t1.findPrefix(p1)<<endl;
  cout<<*t2.findPrefix(p2)<<endl;

  return 0;
}
